##############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : Dr. Detlef Groth
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <031124.1156>
#
#  Description	
#
#  Notes
#
#  History
#	
#  $Log$
#
##############################################################################
#
#  Copyright (c) 2003 MPIMG Berlin, Germany.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################

package provide app-dgBlastParser 1.0
package require Tk
package require BWidget
package require iniparse
package require Wikit
package require starkit
set dir [file dirname [info script]] 
source [file join $dir iniload.tcl]
source [file join $dir dgutils.tcl]
global var
global gui
global data
global img
global mnu
set var(filemode) false
proc main {} {
    global gui var img data mnu
    set var(appname) [file rootname [file tail [info script]]]
    set dir [file dirname [info script]]
    if {[file rootname [file tail [info nameofexe]]] ne $var(appname)} {
        catch {wm iconbitmap . -default "[file join $dir .. .. tclkit.ico]"}
    }
    wm title . "$var(appname) by Dr. Detlef Groth, 2003"
    menu .menubar
    . config -menu .menubar
    set mnu(file) [menu .menubar.file -tearoff 0]
    .menubar add cascade -label File -underline 0 -menu $mnu(file) 
    set mnu(help) [menu .menubar.help -tearoff 0]
    .menubar add cascade -label Help -underline 0 -menu $mnu(help) 
    $mnu(help) add command -label "About ... " -underline 0 -command \
             { tk_messageBox -title "About!" -icon info \
              -message "$var(appname) by Dr. Detlef Groth\n\n     2003\n\n   detlef@dgroth.de" -type ok}
    
    $mnu(help) add command -label "Help" -underline 0 -command {
        if { [winfo exists .help] } {
            wm deiconify .help
        } else {
            set docdir [file join [file dirname [info script]] doc]
            if { [info exist var(starkit)] } {
                set docdir "$argv0/doc"
            } 
            toplevel .help ; 
            Wikit::init [file join $docdir $var(appname).tkd] 1 .help
        }
    }
  

  
   
 
    $mnu(file) add separator
    $mnu(file) add command -label "Open BlastFile ..." -underline 0 -command {
        set types {
            {{Text Files}       {.txt}        }
            {{All Files}        *             }
        }
        set filename [tk_getOpenFile -filetypes $types -title "Open Blastfile"]
        if {$filename != ""} {
            open_file $filename
            
        }
    }
    $mnu(file) add command -label "Save all alignments ..." -underline 0 -command { save_all alignments} -state disabled
    $mnu(file) add command -label "Save all sequences ..." -underline 1 -command { save_all sequences} -state disabled
    set mnu(file-recent) [menu .menubar.file.recent -tearoff 0]
    .menubar.file add cascade -label "Recent Files ..." -underline 0 -menu $mnu(file-recent) 
    ini_load RECENTS 10 LASTFILE 1
    ini_mnu_install $mnu(file-recent) RECENTS open_file 9
    #adjust the proper commands
    ini_mnu_update  $mnu(file-recent) RECENTS open_file 9
    $mnu(file) add separator
    $mnu(file) add command -label Exit -underline 1 -command  {ini_write ; destroy .}
    set widgets [Panned .f top ListBox frame]
    set gui(lb) [lindex $widgets 1]
    $gui(lb) bindText <1> lb_click
    $gui(lb) bindText <Double-1> lb_dbl_click
    set f [lindex $widgets 2]
    set widgets [Panned $f.f left text text]
    set gui(texttop) [lindex $widgets  1]
    set gui(textbottom) [lindex $widgets  2]
    $gui(texttop) configure -font "Courier 10"
    $gui(textbottom) configure -font "Courier 10"
   
    $gui(texttop) tag configure header -foreground blue -underline 1
    $gui(texttop) tag configure error -foreground darkred
   
   
    $gui(textbottom) tag configure header -foreground blue -underline 1
     
}
proc save_all {modus} {
    global gui var
    set var(filemode) true
    set types {
        {{Text Files}       {.txt}        }
        {{All Files}        *             }
    }
   
    set savefile [tk_getSaveFile -filetypes $types]
    if {$savefile != ""} {
        set out [open $savefile w 0600]
        set full [llength [$gui(lb) items]]
        
        set flag false
        set flagflag false
        if [catch {open $var(filename) r} infh] {
            tk_messageBox -title "Info!" -icon info -message "Cannot open $var(filename): $infh ..." -type ok
        } else {
            busy $gui(lb) $gui(texttop) $gui(textbottom)
            set items [llength [$gui(lb) items]]
       
            set var(pro) 0
            ProgressDlg .dlg -parent .  -title "Saving File ..." \
                      -variable var(pro) \
                      -maximum  $items 
            update 
            update idletasks
            set hit 0
            while {[gets $infh line] >= 0} {
          
                if {[regexp {^Query= ([^\s]+)} $line match query]} {
                    if { $modus eq "alignments" } { puts $out "$line\n" }
                    incr var(pro)
                    set hit 0
                    set flag true
                } elseif  { $flag } {
                    if [string match "*No hits found*" $line] {
                        if { $modus eq "alignments" } { puts $out "$line\n" }
                    }
                    if {[regexp {^>(.+)} $line match head]} {
                        incr hit
                    } 
                    if {$hit == 1} {
                        
                        if {[regexp {Frame = (.[0-9])} $line match frame]} {
                            if { $modus eq "sequences" } { puts $out "\n>$query.Frame$frame.$head" }
                        } elseif {[regexp -- {Sbjct: [0-9]+ +([-A-Za-z]+)} $line match seq]} {
                             if { $modus eq "sequences" } { puts $out "$seq" }
                        }
                          if { $modus eq "alignments" } { puts $out "$line\n" }
                        
                    }
                }
                
            }
        }
        close $infh
        unbusy $gui(lb) $gui(texttop) $gui(textbottom)
        close $out
        destroy .dlg
        tk_messageBox -title "Info!" -icon info -message "$savefile was saved!" -type ok
    }
}

proc lb_dbl_click { node } {
    global var gui
    set flag false
    set flagflag false
    if [catch {open $var(filename) r} infh] {
        tk_messageBox -title "Info!" -icon info -message "Cannot open $var(filename): $infh ..." -type ok
    } else {
        busy $gui(lb) $gui(texttop) $gui(textbottom)
        update 
        update idletasks
        $gui(texttop) delete 1.0 end
        $gui(textbottom) delete 1.0 end
        set query [$gui(lb) itemcget $node -text]
        set pos [$gui(lb) itemcget $node -data]
        seek $infh $pos start
        set curr 3
        while {[gets $infh line] >= 0} {
            if {[regexp "^Query= $query" $line match]} {
                $gui(texttop) insert end "$line\n" header
                set flag true
            } elseif { $flag && [regexp "Query= " $line match]} {
                break
            } elseif  { $flag } {
                if [string match "*No hits found*" $line] {
                    $gui(texttop) insert end $line error
                }
                if {$flagflag && [regexp {^>} $line match]} {
                    break
                } elseif {[regexp {^>(.+)} $line match head]} {
                    set flagflag true
                    $gui(texttop) insert end "$line\n"
                    
                    
                } elseif {$flagflag} {
                    
                    if {[regexp {Frame = (.[0-9])} $line match frame]} {
                        $gui(textbottom) insert end "\n>$query.Frame$frame.$head\n" header
                    } elseif {[regexp -- {Sbjct: [0-9]+ +([-A-Za-z]+)} $line match seq]} {
                        $gui(textbottom) insert end "$seq"
                    }
                    $gui(texttop) insert end "$line\n"
                }
                
            }
        }
        close $infh
        unbusy $gui(lb) $gui(texttop) $gui(textbottom)
      }
               
    
    
}
proc lb_click { node } {
    global gui
    $gui(lb) selection set $node
    
    
}
proc open_file { filename } {
    global gui var mnu pos
    set var(filename) $filename
    set var(lastdir) [file dirname $filename]
    ini_unshift RECENTS $filename 9
    ini_option_set LASTDIR $var(lastdir)
    ini_mnu_update $mnu(file-recent) RECENTS open_file 9
    $gui(lb) delete [$gui(lb) items]
    set items 0
    if [catch {open $filename r} infh] {
        tk_messageBox -title "Info!" -icon info -message "Cannot open $filename: $infh ..." -type ok
    } else {
        busy $gui(lb) $gui(textbottom) $gui(texttop)
        update 
      
        set lines [countLines $filename]
       
        set var(pro) 0
        ProgressDlg .dlg -parent .  -title "Loading File ..." \
                  -variable var(pro) \
                  -maximum  $lines 
    
        set linenr 0
        while {[gets $infh line] >= 0} {
            incr linenr
            if {[expr $linenr % 1000] == 0} {
                set var(pro) $linenr
                update
            }
            if {[regexp {^Query= (.+)} $line match query]} {
              
                $gui(lb) insert end #auto -text $query -image [Bitmap::get file] -data $pos
                
            }
            set pos [ tell $infh ]
           
            
        }
        close $infh
        unbusy $gui(lb) $gui(textbottom) $gui(texttop)
        destroy .dlg
    }
    $mnu(file) entryconfigure 3  -state normal
    $mnu(file) entryconfigure 2  -state normal
}
main
