##############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : Dr. Detlef Groth
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <030625.1137>
#
#  Description	
#
#  Notes
#
#  History
#	
#  $Log$
#
##############################################################################
#
#  Copyright (c) 2003 MPIMG Berlin, Germany.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################
proc PannedTop {f side args} {
    frame $f
    pack [PanedWindow $f.pw -side left -pad 0] -fill both -expand true
    set x 0
    lappend widgets $f.pw
    foreach el $args {
        set pane [$f.pw add -weight 1]
        if { $el ne "frame" } {
            set w [Scrolled $pane.f $el]
        }
        lappend widgets $w
        incr x
    }
    pack $f -side top -fill both -expand true
    return $widgets
   
}
proc Panned {f side args} {
    frame $f
    pack [PanedWindow $f.pw -side $side -pad 0] -fill both -expand true
    set x 0
    lappend widgets $f.pw
    foreach el $args {
        set pane [$f.pw add -weight 1]
        if { $el ne "frame" } {
            set w [Scrolled $pane.f $el]
        } else {
            pack [frame $pane.fr] -side top -fill both -expand yes
            set w $pane.fr
        }
        lappend widgets $w
        incr x
    }
    pack $f -side top -fill both -expand true
    return $widgets
   
}

proc Scrolled {f widget args} {
    frame $f
    # The setgrid setting allows the window to be resized.
    eval { $widget $f.text -xscrollcommand [list $f.xscroll set] \
              -yscrollcommand [list $f.yscroll set]  } $args
   
    scrollbar $f.xscroll -orient horizontal  -command [list $f.text xview]
    scrollbar $f.yscroll -orient vertical  -command [list $f.text yview]
    pack $f.xscroll -side bottom -fill x
    pack $f.yscroll -side right -fill y
    # The fill and expand are needed when resizing.
    pack $f.text -side left -fill both -expand true
    pack $f -side top -fill both -expand true
    return $f.text
}
proc ScrolledY {f widget args} {
    frame $f
    # The setgrid setting allows the window to be resized.
    eval { $widget $f.text \
              -yscrollcommand [list $f.yscroll set]  } $args
   
    scrollbar $f.yscroll -orient vertical  -command [list $f.text yview]
    pack $f.yscroll -side right -fill y
    # The fill and expand are needed when resizing.
    pack $f.text -side left -fill both -expand true
    pack $f -side top -fill both -expand true
    return $f.text
}
proc iincr { varName {amount 1}} {
    # improved incr which also incr non existing vars
    upvar 1 $varName var
    if {[info exists var]} {
        set var [expr $var + $amount]
    } else {
        set var $amount
    }
    return $var
}
proc ldelete { list value } {
    # deleting a item by value
    set ix [lsearch -exact $list $value]
    if {$ix >= 0} {
        return [lreplace $list $ix $ix]
    } else {
        return $list
    }
}

proc luniq {myList} {
    foreach elem $myList {
        set temp($elem) 1
    }
    set newList [list]
    foreach elem [lsort -dictionary [array names temp]] {
        lappend newList $elem
    } 
    return $newList
}
proc getBoolean { string } {
    if { $string eq false } {
        return false
    } elseif { $string eq no } {
        return false
    } elseif { $string eq "0" } {
        return false
    } elseif { [string length $string] > 1 } {
        return true
    } else {
        return true
    }
}
proc push { stack value } {
	upvar $stack S
	if {![info exists S(top)]} {
		set S(top) 0
	}
	set S($S(top)) $value
	incr S(top)
}
proc pop { stack } {
	upvar $stack S
	if {![info exists S(top)]} {
		return {}
	}
	if {$S(top) == 0} {
		return {}
	} else {
		incr S(top) -1
		set x $S($S(top))
		unset S($S(top))
		return $x
	}
    }
    
# sleep implementation

# Will suspend evaluation of current code block, but allow the event loop to
# continue handling pending events.

# This particular version of uniqkey is my favorite because the keys generated
# will generally sort in time created order.

 proc uniqkey { } {
     set key   [ expr { pow(2,31) + [ clock clicks ] } ]
     set key   [ string range $key end-8 end-3 ]
     set key   [ clock seconds ]$key
     return $key
 }

 proc sleep { ms } {
     set uniq [ uniqkey ]
     set ::__sleep__tmp__$uniq 0
     after $ms set ::__sleep__tmp__$uniq 1
     vwait ::__sleep__tmp__$uniq
     unset ::__sleep__tmp__$uniq
 }
 
 proc busy {args} {
    foreach el $args {
        $el configure -cursor watch
    }
    update 
    update idletasks
}
proc unbusy {args} {
    foreach el $args {
        $el configure -cursor arrow
    }
}
proc countLines filename {
    set lines 0
    if [catch {open $filename r} infh] {
        puts stderr "Cannot open $filename: $infh"
        exit
    } else {
        while {[gets $infh line] >= 0} {
            incr lines
            
        }
        close $infh
        
    }
    return $lines
}
